class APPLICATION

creation

	make

feature {NONE}
	output: OUTPUTWINDOW;
		-- Fenster fr die Ausgabe

	objectlist: LIST_PRIMITIVE;
		-- in objectlist werden alle grafischen Objekte
		-- aufbewahrt
	undolist: LIST_GOVISITOR;
		-- in undolist werden alle bereits angewendete
		-- Besucher fr ein spteres UNDO aufbewahrt

	demo is
		-- demonstriert den Einsatz der Besucher auf grafische Objekte
		local
			visitor: GOVISITOR;
				-- Besucher, der auf die Objekte in objectlist angewendet
				-- wird und dann in der undolist abgelegt wird
			p: PRIMITIVE;
				-- Objekt (Primitiv)

		do

			!!objectlist.make;
				-- Objektstruktur (hier Liste) erzeugen
			!!undolist.make;
				-- UNDO-Liste erzeugen

			!POINT!p.make (100,100);
			objectlist.extend (p);
			!LINE!p.make (10,10,50,50);
			objectlist.extend (p);
			!CIRCLE!p.make (30,100,25);
			objectlist.extend (p);

			from
				objectlist.start
			until
				objectlist.off
			loop
				objectlist.item.paint (output.dc)
				objectlist.item.textout
				io.new_line
				objectlist.forth
			end;

			io.new_line;
			io.putstring ("----DO MOVE--Entlang des Vektors (200, 0) bewegen----");
			io.new_line;

			!MOVEVISITOR!visitor.make (200, 0, TRUE);
				-- entlang des Vektors (200, 0) bewegen
		
			from
				objectlist.start
			until
				objectlist.off
			loop
				objectlist.item.receive (visitor)
					-- "Besuch abstatten"
				objectlist.item.paint (output.dc)
				objectlist.item.textout
				io.new_line
				objectlist.forth
			end;

			undolist.extend (visitor);
				-- den aktuellen Besucher, und damit die Aktion
				-- auf der Objektliste fr ein spteres UNDO
				-- in der undolist aufbewahren

			io.new_line;
			io.putstring ("----DO MIRROR--An y=150 spiegeln----");
			io.new_line;

			!MIRRORVISITOR!visitor.makev (150);
				-- An y=150 spiegeln

			from
				objectlist.start
			until
				objectlist.off
			loop
				objectlist.item.receive (visitor)
					-- "Besuch abstatten"
				objectlist.item.paint (output.dc)
				objectlist.item.textout
				io.new_line
				objectlist.forth
			end;

			undolist.extend (visitor);
				-- den aktuellen Besucher, und damit die Aktion
				-- auf der Objektliste fr ein spteres UNDO
				-- in der undolist aufbewahren

			io.new_line;
			io.putstring ("----DO ZOOM--Um den Punkt (0, 0) mit Faktor 1.5 expandieren----");
			io.new_line;

			!ZOOMVISITOR!visitor.make (0,0,1.5, TRUE);
				-- Um den Punkt (0, 0) mit Faktor 1.5 expandieren
			from
				objectlist.start
			until
				objectlist.off
			loop
				objectlist.item.receive (visitor)
					-- "Besuch abstatten"
				objectlist.item.paint (output.dc)
				objectlist.item.textout
				io.new_line
				objectlist.forth
			end;

			undolist.extend (visitor);
				-- den aktuellen Besucher, und damit die Aktion
				-- auf der Objektliste fr ein spteres UNDO
				-- in der undolist aufbewahren

			io.new_line;
			io.putstring ("----UNDO ZOOM----");
			io.new_line;

			visitor.undo_redo;			
			from
				objectlist.start
			until
				objectlist.off
			loop
				objectlist.item.receive (visitor)
					-- "Besuch abstatten"
				objectlist.item.paint (output.dc)
				objectlist.item.textout
				io.new_line
				objectlist.forth
			end;

			undolist.finish;
			undolist.remove;
			undolist.finish;

		end;

	make is
		once
			-- Nur eine Instanz zulassen

			io.putstring ("REPAINT nicht implementiert!%N");
			!!output.make;
				-- Erzeuge grafisches Ausgabefenster
			demo;
			io.putstring ("Enter zum Beenden drcken!");
			io.readline
		end;

end -- class APPLICATION
