class MIRRORVISITOR inherit GOVISITOR
	-- Besucher, der Objekte spiegelt
	-- Spiegelung nur orthogonal (horizontal, vertikal)

creation

	makeh, makev 

feature {ANY}

	makeh (xs: REAL) is
		-- erzeugt horizontalen Mirror
		do
			x:= xs;
			y:= 0;
			horizontal:= TRUE;

			ensure
				x = xs;
				y = 0;
				horizontal;
		end;

	makev (ys: REAL) is
		-- erzeugt verikalen Mirror
		do
			x:= 0;
			y:= ys;
			horizontal:= FALSE;

			ensure
				x = 0;
				y = ys;
				not horizontal;
		end;

	visitPOINT (p: POINT) is
		do
			if horizontal then
				p.setx ( (- (p.x - x)) + x)
			else
				p.sety ( (- (p.y - y)) + y)
			end
		end;
	visitLINE (l: LINE) is
		do
			l.first.receive (current);
			l.last.receive (current);
		end;
	visitCIRCLE (c: CIRCLE) is
		do
			c.center.receive (current);
		end;

feature {NONE}

	x, y: REAL;
		-- an (x,0) und (0,y) wird gespiegelt
	horizontal: BOOLEAN;
		-- Richtung

end -- class MIRRORVISITOR