class MOVEVISITOR inherit GOVISITOR
	-- Besucher, der Objekte verschiebt

creation

	make

feature {ANY}

	make (x, y: REAL; d: BOOLEAN) is
		do
			vectorx:= x;
			vectory:= y;
			doit:= d;

			ensure
				vectorx = x;
				vectory = y;
				doit = d;
		end;

	visitPOINT (p: POINT) is
		do
			if  doit then
				p.setx ( p.x + vectorx);
				p.sety ( p.y + vectory);
			else
				p.setx ( p.x - vectorx);
				p.sety ( p.y - vectory);
			end;
				
			if (p.x > maxx) then
				maxx:= p.x;
			end;
			if (p.x < minx) then
				minx:= p.x;
			end;
			if (p.y > maxy) then
				maxy:= p.y
			end;
			if (p.y < miny) then
				miny:= p.y;
			end;
		end;

	visitLINE (l: LINE) is
		-- den Besucher (sich selbst) auf die beiden Endpunkte anwenden
		do
			l.first.receive (current);
			l.last.receive (current);
		end;

	visitCIRCLE (c: CIRCLE) is
		-- den Besucher (sich selbst) auf den Mittelpunkt anwenden
		do
			c.center.receive (current);
		end;

feature {NONE}

	vectorx, vectory: REAL;
		-- Verschiebungsrichtung

end -- class MOVEVISITOR