class ZOOMVISITOR inherit GOVISITOR
	-- Besucher, der Objekte zoomt

creation

	make

feature {ANY}

	make (xs, ys, factors: REAL; d: BOOLEAN) is
		do
			x:= xs;
			y:= ys;
			doit:= d;
			factor:= factors;

			ensure
				x = xs;
				y = ys;
				doit = d;
				factor = factors;
		end;

	visitPOINT (p: POINT) is
		do
			if doit then
				p.setx( factor * (p.x - x) + x);
				p.sety( factor * (p.y - y) + y);
			else
				p.setx( (1/factor) * (p.x - x) + x);
				p.sety( (1/factor) * (p.y - y) + y);
			end;				
		end;

	visitLINE (l: LINE) is
		-- den Besucher (sich selbst) auf die beiden Endpunkte anwenden
		do
			l.first.receive (current);
			l.last.receive (current);
		end;

	visitCIRCLE (c: CIRCLE) is
		-- den Besucher (sich selbst) auf die beiden Endpunkte anwenden
		-- und den Radius anpassen
		do
			c.center.receive (current);
			if doit then
				c.setradius (c.radius * factor);
			else
				c.setradius (c.radius * (1 / factor));
			end;
		end;

feature {NONE}

	x, y, factor: REAL;
		-- Ursprung der Expansion / Kompression und Zoomfaktor

end -- class ZOOMISITOR 

